'use strict';

Object.defineProperty(exports, "__esModule", {
				value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _xmldom = require('xmldom');

var _eslint = require('./eslint');

var _eslint2 = _interopRequireDefault(_eslint);

var _cache = require('./cache');

var _cache2 = _interopRequireDefault(_cache);

var _util = require('./util');

var _util2 = _interopRequireDefault(_util);

var _escodegen = require('escodegen');

var _escodegen2 = _interopRequireDefault(_escodegen);

var _crypto = require('crypto');

var _crypto2 = _interopRequireDefault(_crypto);

var _compileConfig = require('./compile-config');

var _compileConfig2 = _interopRequireDefault(_compileConfig);

var _compileStyle = require('./compile-style');

var _compileStyle2 = _interopRequireDefault(_compileStyle);

var _compileTemplate = require('./compile-template');

var _compileTemplate2 = _interopRequireDefault(_compileTemplate);

var _compileScript = require('./compile-script');

var _compileScript2 = _interopRequireDefault(_compileScript);

var _index = require('./web/index');

var _index2 = _interopRequireDefault(_index);

var _loader = require('./loader');

var _loader2 = _interopRequireDefault(_loader);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var acorn = require('acorn');
require('acorn-es7-plugin')(acorn);
var acorn_walk = require('acorn/dist/walk');
/*import cLess from './compile-less';
import cSass from './compile-sass';
import cCss from './compile-css';*/
exports.default = {
				_cacheWpys: {},
				createParser: function createParser() {
								return new _xmldom.DOMParser({ errorHandler: {
																warning: function warning(x) {
																				_util2.default.warning(x);
																				if (x.indexOf('missed value!!') > -1) {
																								// ignore warnings
																				} else _util2.default.warning(x);
																},
																error: function error(x) {
																				_util2.default.error(x);
																}
												} });
				},
				getMappingName: function getMappingName(str) {
								var stash = [],
								    rst = '';
								var isValue = false;
								for (var i = 0; i < str.length; i++) {
												if (str[i] === '{') {
																stash.push('{');
												}
												if (stash.length === 1) {

																if (str[i] === ',') {
																				isValue = false;
																}
																if (!isValue || str[i] === '}') {
																				rst += str[i];
																} else {
																				rst += 0;
																}
																if (str[i] === ':') {
																				isValue = true;
																}
												}
												if (str[i] === '}') {
																stash.pop();
																if (stash.length === 1) {
																				rst += '1';
																}
												}
								}
								return rst;
				},
				grabConfigFromScript: function grabConfigFromScript(str, n) {
								var stash = [],
								    rst = '';
								for (var i = n, l = str.length; i < l; i++) {
												if (str[i] === '{') stash.push('{');
												if (str[i] === '}') {
																stash.pop();
																if (stash.length === 0) {
																				rst += '}';
																				break;
																}
												}
												if (stash.length) {
																rst += str[i];
												}
								}
								return rst;
				},

				/*
    Use components instead, unused functions
     */
				resolveRelation: function resolveRelation(xml) {
								var requires = [];
								var matchs = xml.match(/<component[^/>]*\/>/ig);

								(matchs || []).forEach(function (m) {
												var rst = void 0;
												if (m.indexOf('path') > -1) {
																rst = m.match(/path\s*=\s*['"](.*)['"]/);
												} else {
																rst = m.match(/id\s*=\s*['"](.*)['"]/);
												}
												if (rst[1] && requires.indexOf(rst[1]) === -1) requires.push(rst[1]);
								});
								return requires;
				},
				resolveWpy: function resolveWpy(xml, opath) {
								var _this = this;

								// // console.log('resolve', xml)
								var config = _util2.default.getConfig();
								var filepath = void 0;

								if ((typeof xml === 'undefined' ? 'undefined' : _typeof(xml)) === 'object' && xml.dir) {
												opath = xml;
												filepath = _path2.default.join(xml.dir, xml.base);
								} else {
												opath = _path2.default.parse(xml);
												filepath = xml;
								}
								var content = _util2.default.readFile(filepath);

								if (content === null) {
												_util2.default.error('打开文件失败: ' + filepath);
												return null;
								}
								if (content === '') {
												return null;
								}

								var startlen = content.indexOf('<script') + 7;
								if (startlen >= 7 && content.length >= 8) {
												// this is no scripts
												while (content[startlen++] !== '>') {
																// do nothing;
												}
												content = _util2.default.encode(content, startlen, content.indexOf('</script>') - 1);
								}
								// replace :attr to v-bind:attr
								/*content = content.replace(/<[\w-\_]*\s[^>]*>/ig, (tag) => {
            return tag.replace(/\s+:([\w-_]*)([\.\w]*)\s*=/ig, (attr, name, type) => { // replace :param.sync => v-bind:param.sync
                if (type === '.once' || type === '.sync') {
                }
                else
                    type = '.once';
                return ` v-bind:${name}${type}=`;
            }).replace(/\s+\@([\w-_]*)\s*=/ig, (attr, name) => { // replace @change => v-on:change
                return `v-on:${name}`;
            });
        })*/

								content = _util2.default.attrReplace(content);

								xml = this.createParser().parseFromString(content);
								var moduleId = _util2.default.genId(filepath);

								var rst = {
												moduleId: moduleId,
												style: [],
												template: {
																code: '',
																src: '',
																type: ''
												},
												script: {
																code: '',
																src: '',
																type: ''
												}
								};

								[].slice.call(xml.childNodes || []).forEach(function (child) {
												var nodeName = child.nodeName;
												if (nodeName === 'style' || nodeName === 'template' || nodeName === 'script') {
																var rstTypeObj = void 0;

																if (nodeName === 'style') {
																				rstTypeObj = { code: '' };
																				rst[nodeName].push(rstTypeObj);
																} else {
																				rstTypeObj = rst[nodeName];
																}

																rstTypeObj.src = child.getAttribute('src');
																rstTypeObj.type = child.getAttribute('lang') || child.getAttribute('type');
																if (nodeName === 'style') {
																				// 针对于 style 增加是否包含 scoped 属性
																				rstTypeObj.scoped = child.getAttribute('scoped') ? true : false;
																}

																if (rstTypeObj.src) {
																				rstTypeObj.src = _path2.default.resolve(opath.dir, rstTypeObj.src);
																				rstTypeObj.link = true;
																} else {
																				rstTypeObj.link = false;
																}

																if (rstTypeObj.src && _util2.default.isFile(rstTypeObj.src)) {
																				var fileCode = _util2.default.readFile(rstTypeObj.src, 'utf-8');
																				if (fileCode === null) {
																								throw '打开文件失败: ' + rstTypeObj.src;
																				} else {
																								rstTypeObj.code += fileCode;
																				}
																} else {
																				[].slice.call(child.childNodes || []).forEach(function (c) {
																								rstTypeObj.code += _util2.default.decode(c.toString());
																				});
																}

																if (!rstTypeObj.src) rstTypeObj.src = _path2.default.join(opath.dir, opath.name + opath.ext);
												}
								});

								if (rst.style.length === 0) {
												rst.style.push({
																code: '',
																src: _path2.default.join(opath.dir, opath.name + opath.ext),
																type: 'sass',
																scoped: true,
																link: false
												});
								}

								//util.mergeWpy(rst);

								/*
        Use components instead
        if (rst.template.code) {
            rst.template.requires = this.resolveRelation(rst.template.code);
        }*/

								// default type
								rst.template.type = rst.template.type || 'wxml';
								rst.script.type = rst.script.type || 'babel';

								// get config
								(function () {
												var match = rst.script.code.match(/[\s\r\n]config\s*[=:][\s\r\n]*/);
												match = match ? match[0] : undefined;

												rst.config = match ? _this.grabConfigFromScript(rst.script.code, rst.script.code.indexOf(match) + match.length) : false;
												try {
																if (rst.config) {
																				rst.config = new Function('return ' + rst.config)();
																}
												} catch (e) {
																_util2.default.output('错误', _path2.default.join(opath.dir, opath.base));
																_util2.default.error('\u89E3\u6790config\u51FA\u9519\uFF0C\u62A5\u9519\u4FE1\u606F\uFF1A' + e + '\r\n' + rst.config);
												}
								})();

								// pre compile wxml
								(function () {
												if (rst.template.type !== 'wxml' && rst.template.type !== 'xml') {
																var compiler = _loader2.default.loadCompiler(rst.template.type);
																if (compiler && compiler.sync) {
																				if (rst.template.type === 'pug') {
																								// fix indent for pug, https://github.com/wepyjs/wepy/issues/211
																								var indent = _util2.default.getIndent(rst.template.code);
																								if (indent.firstLineIndent) {
																												rst.template.code = _util2.default.fixIndent(rst.template.code, indent.firstLineIndent * -1, indent.char);
																								}
																				}
																				var compilerConfig = config.compilers[rst.template.type];

																				// xmldom replaceNode have some issues when parsing pug minify html, so if it's not set, then default to un-minify html.
																				if (compilerConfig.pretty === undefined) {
																								compilerConfig.pretty = true;
																				}

																				rst.template.code = compiler.sync(rst.template.code, config.compilers[rst.template.type] || {});
																				rst.template.type = 'wxml';
																}
												}
												if (rst.template.code) {
																rst.template.node = _this.createParser().parseFromString(_util2.default.attrReplace(rst.template.code));
												}
								})();

								// get imports
								(function () {

												var coms = {};
												rst.script.code.replace(/import\s*([\w\-\_]*)\s*from\s*['"]([\w\-\_\.\/]*)['"]/ig, function (match, com, compath) {
																coms[com] = compath;
												});

												var match = rst.script.code.match(/[\s\r\n]components\s*[=:][\s\r\n]*/);
												match = match ? match[0] : undefined;

												rst.script.code = rst.script.code.replace(/import\s*([\w\-\_]*)\s*from\s*['"]([\w\-\_\.\/]*)['"]/ig, function (match, com, compath) {
																var reg = new RegExp(_cache2.default.getExt(), 'g');
																match = match.replace(reg, '');
																return match;
												});

												rst.script.code = rst.script.code.replace(/\.weexComponent/ig, '');
												// // console.log(rst.script.code)

												rst.script.code = rst.script.code.replace(/require\(['"](.*?)(\.png|\.jpg)['"]\s*\)/ig, function (match, path, ext) {
																return '"' + path + ext + '"';
												});

												var components = match ? _this.grabConfigFromScript(rst.script.code, rst.script.code.indexOf(match) + match.length) : false;
												var vars = Object.keys(coms).map(function (com, i) {
																return 'var ' + com + ' = "' + coms[com] + '";';
												}).join('\r\n');
												try {
																if (components) {
																				components = components.replace(/\.weexComponent/ig, '');
																				rst.template.components = new Function(vars + '\r\nreturn ' + components)();
																} else {
																				rst.template.components = {};
																}
												} catch (e) {
																_util2.default.output('错误', _path2.default.join(opath.dir, opath.base));
																_util2.default.error('\u89E3\u6790components\u51FA\u9519\uFF0C\u62A5\u9519\u4FE1\u606F\uFF1A' + e + '\r\n' + vars + '\r\nreturn ' + components);
												}
								})();

								/*
        	v-for  ---->  repeat
         */
								(function () {
												if (!rst.template.node) return;
												var arr = _util2.default.elemRecursion(rst.template.node.childNodes);
												arr.reverse().forEach(function (elem) {
																var vfor = elem.getAttribute('v-for');
																// console.log('vfor',vfor);

																var tmp = void 0;
																var t = false;
																vfor.replace(/\s*\(?\s*([^\s\(\)]*)\s*,\s*([^\s\(\)]*)\s*\)?\s*in\s*([^\s]*)/g, function (match, item, index, items) {
																				t = true;
																				//util.Log('vfor',match,item,index,items);
																				// elem.setAttribute('wx:for',`{{${items}}}`);
																				// elem.setAttribute('wx:for-index',`{{${index}}}`);
																				// elem.setAttribute('wx:for-item',`{{${item}}}`);
																				// elem.removeAttribute('v-for');
																				tmp = {
																								for: '{{' + items + '}}',
																								item: item,
																								index: index,
																								key: index

																								// console.log('vfor tmp=',tmp);

																				};var doc = new _xmldom.DOMImplementation().createDocument();
																				var repeat = doc.createElement('repeat');
																				repeat.setAttribute('for', tmp.for);
																				repeat.setAttribute('item', tmp.item);
																				repeat.setAttribute('index', tmp.index);
																				repeat.setAttribute('key', tmp.key);

																				elem.removeAttribute('v-for');

																				var parentNode = elem.parentNode;

																				var newElem = elem.cloneNode(true);
																				repeat.appendChild(newElem);
																				parentNode.replaceChild(repeat, elem);

																				// let array = util.elemRecursion(newElem.childNodes);
																				// // console.log('@@@ array.length=',array.length);
																				// arr = arr.concat(array);
																				// parentNode.appendChild(repeat);
																});

																if (!t) {
																				vfor.replace(/\s*\(?\s*([a-zA-Z$_][a-zA-Z0-9$_]*)\s*\)?\s*in\s*([a-zA-Z$_][a-zA-Z0-9$_]*)/g, function (match, item, items) {

																								//util.Log('vfor',match,item,items);
																								// elem.setAttribute('wx:for',`{{${items}}}`);
																								// elem.setAttribute('wx:for-index',`{{${index}}}`);
																								// elem.setAttribute('wx:for-item',`{{${item}}}`);
																								// elem.removeAttribute('v-for');
																								tmp = {
																												for: '{{' + items + '}}',
																												item: item,
																												index: 'index',
																												key: 'index'
																								};

																								var doc = new _xmldom.DOMImplementation().createDocument();
																								var repeat = doc.createElement('repeat');
																								repeat.setAttribute('for', tmp.for);
																								repeat.setAttribute('item', tmp.item);
																								repeat.setAttribute('index', tmp.index);
																								repeat.setAttribute('key', tmp.key);

																								elem.removeAttribute('v-for');

																								var parentNode = elem.parentNode;
																								repeat.appendChild(elem.cloneNode(true));
																								parentNode.replaceChild(repeat, elem);
																								// parentNode.appendChild(repeat);
																				});
																}

																if (!tmp) {
																				//util.Log('vfor=',vfor)
																}
												});
												rst.template.code = rst.template.node.toString();
												rst.template.node = _this.createParser().parseFromString(_util2.default.attrReplace(rst.template.code));
								})();

								/*
        	获取props data computed
         */
								(function () {

												var props_match = rst.script.code.match(/[^$]props\s*[=:][\s\r\n]*/);
												props_match = props_match ? props_match[0] : undefined;
												var props = props_match ? _this.grabConfigFromScript(rst.script.code, rst.script.code.indexOf(props_match) + props_match.length) : '';

												var data_match = rst.script.code.match(/[\s\r\n]*data\s*\(\)[\s\r\n]*/);
												data_match = data_match ? data_match[0] : undefined;
												var data = data_match ? _this.grabConfigFromScript(rst.script.code, rst.script.code.indexOf(data_match) + data_match.length) : '';

												var computed_match = rst.script.code.match(/[\s\r\n]*computed\s*[=:][\s\r\n]*/);
												computed_match = computed_match ? computed_match[0] : undefined;
												var computed = computed_match ? _this.grabConfigFromScript(rst.script.code, rst.script.code.indexOf(computed_match) + computed_match.length) : '';

												// console.log('xxx computed=',computed);

												try {
																if (props) {
																				var obj = new Function('return ' + props)();
																				rst.template.props = Object.keys(obj);
																} else {
																				rst.template.props = [];
																}
												} catch (e) {
																_util2.default.output('\u89E3\u6790props\u9519\u8BEF' + e, _path2.default.join(opath.dir, opath.base));
												}

												try {
																if (data) {
																				//util.Log('data=',data);
																				var return_match = data.match(/return/);
																				return_match = return_match ? return_match[0] : undefined;
																				/*
                     	d = {
                     		a: 1,
                     		b: {
                     			a:1,
                     		},
                     		c: {
                     			m:1,
                     		}
                     	}
                     */
																				if (!return_match) {
																								throw new Error('data must be return');
																				}
																				var d = return_match ? _this.grabConfigFromScript(data, data.indexOf(return_match) + return_match.length) : '';

																				var ast = acorn.parse('f=' + d, { sourceType: 'module' });
																				var objs = [];
																				acorn_walk.simple(ast, {
																								ObjectExpression: function ObjectExpression(node) {
																												objs.push(node);
																								}
																				});
																				var data_node = objs[objs.length - 1];
																				var arr = [];
																				var properties = data_node.properties;
																				properties.forEach(function (node) {
																								arr.push(node.key.name);
																				});

																				rst.template.data = arr;
																				//util.Log('rst.template.data=',rst.template.data);
																} else {
																				rst.template.data = [];
																}
												} catch (e) {
																_util2.default.output('\u89E3\u6790data\u9519\u8BEF' + e, _path2.default.join(opath.dir, opath.base));
												}

												try {
																if (computed) {
																				var _obj = new Function('return ' + computed)();
																				rst.template.computed = Object.keys(_obj);
																} else {
																				rst.template.computed = [];
																}
												} catch (e) {
																_util2.default.output('\u89E3\u6790computed\u9519\u8BEF' + e, _path2.default.join(opath.dir, opath.base));
												}
								})();

								/* 属性处理
        1. 处理 :attr="a>0?b:c"   ->
        :attr="weex_computed_xxx"
         
         computed:{
        	 weex_computed_xxx () {
        	 	return this.a>0?this.b:this.c;
        	 }
         }
         
         2. style="color:red"  -> style="display:flex;color:red"
         
         :style="{color:'red'}"  -> :style="{display:'flex',color:'red'}"
         
         3.require('../../../image/tag.png')
         -> ../../../image/tag.png
        
         */

								(function () {

												if (!rst.template.code) {
																return;
												}

												rst.template.node = _this.createParser().parseFromString(_util2.default.attrReplace(rst.template.code));

												// 修改属性值   :attr="a>0?b:c"   ->  :attr="weex_computed_xxx"

												var expComputedMap = {};

												_util2.default.getNodes(rst.template.node).map(function (item) {

																var node = item.node;

																var attrs = node.attributes;

																if (!attrs) {
																				return;
																}
																// //util.Log(node.getAttribute('v-bind.style.once'));
																// //util.Log(attrs);
																[].slice.call(attrs || []).forEach(function (attr) {

																				var k = attr.name;
																				var v = attr.value.trim();

																				if (v.trim() === '') {
																								return;
																				}

																				if (k === 'style') {
																								// v=`display:flex;`+v;
																								v = v.replace(/([^r])px/g, function (m1, m2) {

																												return m2 + 'rpx';
																								});
																								node.setAttribute(k, v);
																								// console.log('v=',v);
																								return;
																				}

																				if (k === 'v-if' || k === 'v-show') {
																								node.setAttribute('wx:if', v);
																								node.removeAttribute(k);
																								k = 'wx:if';
																				}

																				if (k === 'v-else') {
																								node.setAttribute('wx:else', v);
																								node.removeAttribute('v-else');
																								k = 'v-else';
																				}
																				// if (k === 'v-show') {
																				// 	node.setAttribute('v-bind:hidden.once', `!(${v})`);
																				// 	node.removeAttribute('v-show');
																				// }


																				if (k.match(/v-bind:(.*).once/) === null && k.match(/v-bind:(.*).sync/) === null && k !== 'wx:if') {
																								return;
																				}

																				if (k.indexOf('class') !== -1 || k.indexOf('style') !== -1) {
																								// return
																				}

																				if (k.indexOf('style') !== -1) {
																								// v = v.replace(/{/,match=>{
																								// 	match=match+`display:'flex',`
																								// 	return match;
																								// })

																								// console.log('k,v=',k,v);
																								v = v.replace(/([^r])px/g, function (m1, m2) {

																												return m2 + 'rpx';
																								});
																								node.setAttribute(k, v);
																								// return
																				}

																				// console.log('rst.template.data=',rst.template.data);

																				if (rst.template.props.indexOf(v) !== -1 || rst.template.data.indexOf(v) !== -1 || rst.template.computed.indexOf(v) !== -1) {
																								// 如果value直接引用computed、data或者props，则是变量，不做转化
																								return;
																				}

																				// 引用图片
																				var require_match = v.match(new RegExp(/require\((.*)\)/), 'g');
																				if (require_match) {
																								//
																								// let str = require_match[1];
																								// let md5 = crypto.createHash('md5');
																								// let md5_str = md5.update(str).digest('hex');
																								// let computed_name = 'weex_computed_' + md5_str;
																								// expComputedMap[computed_name] = str;
																								// node.setAttribute(k, computed_name);
																								// return;

																								v = require_match[1];
																				}
																				try {
																								var exps = [];
																								var ast = acorn.parse('f=' + v, { sourceType: 'module' });

																								var f = false;
																								acorn_walk.simple(ast, {
																												Expression: function Expression(node) {
																																exps.push(node);
																												},
																												Identifier: function Identifier(node) {

																																// if (opath.base.indexOf('index.vue')!==-1) {
																																// 	// console.log('--f-- node.name',node.name,item.keyword,item.infor);
																																// }
																																if (item.infor) {
																																				// console.log('### item.keyword',item.keyword,node.name);
																																				item.keyword.forEach(function (key) {
																																								// if (node.name.indexOf(key) > 0){
																																								// 	util.Log('f=true',node.name, item.keyword)
																																								// 	f=true
																																								// } else {
																																								//    util.Log('f=true2',node.name, item.keyword)
																																								// }
																																								if (node.name === key) {
																																												f = true;
																																								}
																																				});
																																				// if (item.keyword.indexOf(node.name)===-1) {
																																				// 	node.name = 'this.' + node.name;
																																				// } else {
																																				// 	f = true;
																																				// }
																																}

																																if (!f) {
																																				node.name = 'this.' + node.name;
																																}

																																// if (opath.base.indexOf('index.vue')!==-1) {
																																// 	// console.log('--f-- node.name',node.name);
																																// }
																												}
																								});

																								// if (opath.base.indexOf('index.vue')!==-1) {
																								// 	// console.log('--f--',f);
																								// }


																								var last = exps[exps.length - 2];
																								var str = _escodegen2.default.generate(last, { format: { compact: true } });

																								// console.log('str=',str);
																								var md5 = _crypto2.default.createHash('md5');
																								var md5_str = md5.update(str).digest('hex');

																								var computed_name = 'weex_computed_' + md5_str;

																								if (opath.base.indexOf('index.vue') !== -1) {
																												//util.Log('-exp-',k,v,str);
																								}

																								if (!f) {

																												expComputedMap[computed_name] = str;
																												node.setAttribute(k, computed_name);
																								}
																				} catch (e) {
																								_util2.default.error('\u7F16\u8BD1\u6A21\u677F\u5185\u5D4C\u8868\u8FBE\u5F0F' + v + '\u51FA\u9519' + e + e.stack);
																				}
																});

																[].slice.call(attrs || []).forEach(function (attr) {

																				var k = attr.name;
																				var v = attr.value.trim();
																				_util2.default.Log('attr,k,v=', k, v);
																});
												});

												rst.template.code = rst.template.node.toString();

												if (rst.script.code.indexOf('computed') === -1) {

																//util.Log('no computed',rst.script.code);

																rst.script.code = rst.script.code.replace(/data\s*\(\s*\)\s*{/g, function (match) {

																				var s = '\n\t\t\t\t\tcomputed: {\n\t\t\t\t\t},\n\t\t\t\t\t';
																				return s + match;
																});
																//util.Log('no computed',rst.script.code);
												}

												// 新增 computed
												rst.script.code = rst.script.code.replace(/computed\s*[=|:]\s*{/g, function (match) {

																var s = '';
																Object.keys(expComputedMap).forEach(function (key) {
																				s = s + ('\n                    ' + key + ' () {\n                        return ' + expComputedMap[key] + '\n                    },\n                    ');
																});
																return match + s;
												});
								})();

								// //util.Log('rst.script.code=',rst.script.code);

								// get $props and $events
								(function () {
												if (!rst.template.node) return;
												var coms = Object.keys(rst.template.components);
												var elems = [];
												var props = {};
												var events = {};
												var refs = {};

												var calculatedComs = [];

												// Get components in repeat
												_util2.default.elemToArray(rst.template.node.getElementsByTagName('repeat')).forEach(function (repeat) {
																elems = [];
																if (repeat.getAttribute('for')) {
																				var tmp = {
																								for: repeat.getAttribute('for').replace(/^\s*\{\{\s*/, '').replace(/\s*\}\}\s*$/, ''),
																								item: repeat.getAttribute('item') || 'item',
																								index: repeat.getAttribute('index') || 'index',
																								key: repeat.getAttribute('key') || 'key'
																				};
																				coms.concat('component').forEach(function (com) {
																								elems = elems.concat(_util2.default.elemToArray(repeat.getElementsByTagName(com)));
																				});

																				elems.forEach(function (elem) {
																								calculatedComs.push(elem);
																								var comid = _util2.default.getComId(elem);
																								[].slice.call(elem.attributes || []).forEach(function (attr) {
																												if (attr.name !== 'xmlns:v-bind=""') {
																																if (attr.name !== 'id' && attr.name !== 'path') {
																																				if (/v-on:/.test(attr.name)) {
																																								// v-on:fn user custom event
																																								if (!events[comid]) events[comid] = {};
																																								events[comid][attr.name] = attr.value;
																																				} else {
																																								if (!props[comid]) props[comid] = {};
																																								if (['hidden', 'wx:if', 'wx:elif', 'wx:else'].indexOf(attr.name) === -1) {
																																												props[comid][attr.name] = Object.assign({}, tmp);
																																												props[comid][attr.name]['value'] = attr.value;
																																								}
																																				}
																																}
																												}
																								});
																				});
																}
												});

												elems = [];
												coms.concat('component').forEach(function (com) {
																elems = elems.concat(_util2.default.elemToArray(rst.template.node.getElementsByTagName(com)));
												});
												// //util.Log('elems',elems)
												// //util.Log('props',props)

												elems.forEach(function (elem) {
																// ignore the components calculated in repeat.
																// //util.Log('elem.attributes', elem.attributes)
																if (calculatedComs.indexOf(elem) === -1) {
																				var comid = _util2.default.getComId(elem);
																				[].slice.call(elem.attributes || []).forEach(function (attr) {

																								if (attr.name !== 'id' && attr.name !== 'path') {
																												if (/v-on:/.test(attr.name)) {
																																// v-on:fn user custom event
																																if (!events[comid]) events[comid] = {};
																																events[comid][attr.name] = attr.value;
																												} else {
																																if (!props[comid]) props[comid] = {};
																																if (['hidden', 'wx:if', 'wx:elif', 'wx:else'].indexOf(attr.name) === -1) {
																																				props[comid][attr.name] = attr.value;
																																}
																												}
																								}
																								if (attr.name === 'ref') {
																												var ref = attr.value;
																												refs[ref] = comid;
																								}
																				});
																}
												});
												// //util.Log('props',props)
												if (Object.keys(props).length) {
																rst.script.code = rst.script.code.replace(/[\s\r\n]components\s*([=:])[\s\r\n]*/, function (match, operator) {

																				return '$props ' + operator + ' ' + JSON.stringify(props) + (operator === '=' ? ';' : ',') + '\r\n\n                    $events ' + operator + ' ' + JSON.stringify(events) + (operator === '=' ? ';' : ',') + '\r\n\n                    refs ' + operator + ' ' + JSON.stringify(refs) + (operator === '=' ? ';' : ',') + '\r\n\n                    ' + match;
																});
												}
								})();

								/*
         	处理 :style="mStyle"   ->  style="{{mStyle_weex_style}}"
         	
         	方便后面运行时处理mStyle
          */
								(function () {
												if (!rst.template.node) return;
												rst.template.code = rst.template.node.toString();

												var mStyles = [];

												var m = /v-bind:(.*).(once)/.exec(rst.template.code);

												rst.template.code = rst.template.code.replace(/v-bind:style.once*\s*=\s*\"\s*([a-zA-Z$_][a-zA-Z0-9$_]*)\s*\"/g, function (match, value) {

																//util.Log('style=',match,'value=',value);
																mStyles.push(value);
																var s = 'v-bind:style.once="' + value + '_weex_style"';
																return s;
												});

												try {
																var ast = acorn.parse(rst.script.code, {
																				sourceType: 'module',
																				ecmaVersion: 8,
																				plugins: { asyncawait: true }
																});
																acorn_walk.simple(ast, {
																				MemberExpression: function MemberExpression(node) {
																								var v = node.property;
																								if (mStyles.indexOf(v.name) !== -1) {
																												//util.Log('node=',v.name);
																												v.name = v.name + '_weex_style';
																								}
																				},
																				Property: function Property(node) {
																								if (mStyles.indexOf(node.key.name) !== -1) {
																												node.key.name = node.key.name + '_weex_style';
																								}
																				}
																});
																rst.script.code = _escodegen2.default.generate(ast, { format: { compact: true } });
												} catch (e) {
																_util2.default.error('编译Style计算属性表达式出错:' + e + e.stack);
												}
												// //util.Log('rst.script.code3=',rst.script.code);

								})();

								if (rst.style.some(function (v) {
												return v.scoped;
								}) && rst.template.code) {
												// 存在有 scoped 部分就需要 更新 template.code
												var node = this.createParser().parseFromString(rst.template.code);
												walkNode(node, rst.moduleId);
												// 更新 template.code
												rst.template.code = node.toString();
								}
								this._cacheWpys[filepath] = rst;

								return this._cacheWpys[filepath];
								// return rst;
				},
				remove: function remove(opath, ext) {
								var src = _cache2.default.getSrc();
								var dist = _cache2.default.getDist();
								ext = ext || opath.substr(1);
								var target = _util2.default.getDistPath(opath, ext, src, dist);
								if (_util2.default.isFile(target)) {
												//util.Log('配置: ' + path.relative(util.currentDir, target), '删除');
												_fs2.default.unlinkSync(target);
								}
				},
				lint: function lint(filepath) {
								(0, _eslint2.default)(filepath);
				},
				compile: function compile(opath) {
								// // console.log('compile', opath);
								var filepath = _path2.default.join(opath.dir, opath.base);
								var src = _cache2.default.getSrc();
								var dist = _cache2.default.getDist();
								var wpyExt = _cache2.default.getExt();
								var pages = _cache2.default.getPages();

								var type = '';

								var relative = _path2.default.relative(_util2.default.currentDir, filepath);

								if (filepath === _path2.default.join(_util2.default.currentDir, src, 'app' + wpyExt)) {
												type = 'app';
												//util.Log('入口: ' + relative, '编译');
								} else if (pages.indexOf(relative) > -1) {
												type = 'page';
												//util.Log('页面: ' + relative, '编译');
								} else if (relative.indexOf(_path2.default.sep + 'components' + _path2.default.sep) > -1) {
												type = 'component';
												//util.Log('组件: ' + relative, '编译');
								} else {}
												//util.Log('Other: ' + relative, '编译');


												// Ignore all node modules, avoid eslint warning.
												// https://github.com/eslint/eslint/blob/75b7ba4113db4d9bc1661a4600c8728cf3bfbf2b/lib/cli-engine.js#L325
								if (!opath.npm) {
												this.lint(filepath);
								}

								var wpy = this.resolveWpy(opath);

								if (!wpy) {
												return;
								}

								if (type === 'app') {
												// 第一个编译
												_cache2.default.setPages(wpy.config.pages.map(function (v) {
																return _path2.default.join(src, v + wpyExt);
												}));

												// scoped 设置无效
												wpy.style.forEach(function (rst) {
																return rst.scoped = false;
												});

												// 无template
												delete wpy.template;
								} else if (type === 'component') {
												delete wpy.config;
								}

								if (wpy.config) {
												_compileConfig2.default.compile(wpy.config, opath);
								} else {
												this.remove(opath, 'json');
								}

								if (wpy.style.length || wpy.template && Object.keys(wpy.template.components).length) {
												var requires = [];
												var k = void 0,
												    tmp = void 0;
												if (wpy.template) {
																for (k in wpy.template.components) {
																				tmp = wpy.template.components[k];
																				if (!tmp) {
																								_util2.default.error("文件" + opath.base + ' 引用组件:' + k + '没有路径');
																				}
																				if (tmp.indexOf('.') === -1) {
																								requires.push(tmp); // 第三方组件
																				} else {
																								requires.push(_path2.default.join(opath.dir, wpy.template.components[k]));
																				}
																}
												}
												try {
																_compileStyle2.default.compile(wpy.style, requires, opath, wpy.moduleId);
												} catch (e) {
																_util2.default.error(e);
																process.exit(0);
												}
								} else {
												this.remove(opath, 'wxss');
								}

								if (wpy.template && wpy.template.code && type !== 'component') {
												// App 和 Component 不编译 wxml
												//cTemplate.compile(wpy.template.type, wpy.template.code, opath);
												wpy.template.npm = opath.npm;
												_compileTemplate2.default.compile(wpy);
								}

								if (wpy.script.code) {
												_compileScript2.default.compile(wpy.script.type, wpy.script.code, type, opath);
								}
								// // console.log("compile-wpy.compile finish")
				}
};


function walkNode(node, moduleId) {
				if (node.childNodes) {
								[].slice.call(node.childNodes || []).forEach(function (child) {
												if (child.tagName) {
																// 是标签 则增加class
																var cls = child.getAttribute('class');
																child.setAttribute('class', ('wx-ct ' + cls + ' ' + moduleId).trim());
																walkNode(child, moduleId);
												}
								});
				}
}
//# sourceMappingURL=compile-wpy.js.map